package com.hzs.common.core.service;

import com.hzs.common.core.constant.Constants;
import com.hzs.common.core.constant.msg.MemberMsgConstants;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.BoundSetOperations;
import org.springframework.data.redis.core.HashOperations;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.stereotype.Component;

import java.util.*;
import java.util.concurrent.TimeUnit;

/**
 * spring redis 工具类
 *
 * @author hzs
 **/
@SuppressWarnings(value = {"unchecked", "rawtypes"})
@Component
public class RedisService {

    @Autowired
    public RedisTemplate redisTemplate;

    /**
     * 缓存基本的对象，Integer、String、实体类等
     *
     * @param key   缓存的键值
     * @param value 缓存的值
     */
    public <T> void setCacheObject(final String key, final T value) {
        redisTemplate.opsForValue().set(key, value);
    }

    /**
     * 缓存基本的对象，Integer、String、实体类等
     *
     * @param key      缓存的键值
     * @param value    缓存的值
     * @param timeout  时间
     * @param timeUnit 时间颗粒度
     */
    public <T> void setCacheObject(final String key, final T value, final Long timeout, final TimeUnit timeUnit) {
        redisTemplate.opsForValue().set(key, value, timeout, timeUnit);
    }

    /**
     * 设置有效时间
     *
     * @param key     Redis键
     * @param timeout 超时时间
     * @return true=设置成功；false=设置失败
     */
    public Boolean expire(final String key, final long timeout) {
        return expire(key, timeout, TimeUnit.SECONDS);
    }

    /**
     * 设置有效时间
     *
     * @param key     Redis键
     * @param timeout 超时时间
     * @param unit    时间单位
     * @return true=设置成功；false=设置失败
     */
    public Boolean expire(final String key, final long timeout, final TimeUnit unit) {
        return redisTemplate.expire(key, timeout, unit);
    }

    /**
     * 获取有效时间
     *
     * @param key Redis键
     * @return 有效时间
     */
    public Long getExpire(final String key) {
        return redisTemplate.getExpire(key);
    }

    /**
     * 判断 key是否存在
     *
     * @param key 键
     * @return true 存在 false不存在
     */
    public Boolean hasKey(String key) {
        return redisTemplate.hasKey(key);
    }

    /**
     * 获得缓存的基本对象。
     *
     * @param key 缓存键值
     * @return 缓存键值对应的数据
     */
    public <T> T getCacheObject(final String key) {
        ValueOperations<String, T> operation = redisTemplate.opsForValue();
        return operation.get(key);
    }

    /**
     * 删除单个对象
     *
     * @param key
     */
    public Boolean deleteObject(final String key) {
        return redisTemplate.delete(key);
    }

    public void deleteObjectByKey(final String key) {
        if (Objects.equals(redisTemplate.hasKey(key), Boolean.TRUE)) {
            redisTemplate.delete(key);
        }
    }

    /**
     * 删除集合对象
     *
     * @param collection 多个对象
     * @return
     */
    public Long deleteObject(final Collection collection) {
        return redisTemplate.delete(collection);
    }

    /**
     * 删除map中的某个键
     *
     * @param mapKey map键
     * @param key    键
     * @return
     */
    public Long deleteMapObject(final String mapKey, final String key) {
        return redisTemplate.opsForHash().delete(mapKey, key);
    }

    /**
     * 批量删除map中的键
     *
     * @param mapKey map键
     * @param keys   map中要删除的键
     * @return
     */
    public Long deleteMapObjectArr(final String mapKey, final Object... keys) {
        return redisTemplate.opsForHash().delete(mapKey, keys);
    }

    /**
     * 缓存List数据
     *
     * @param key      缓存的键值
     * @param dataList 待缓存的List数据
     * @return 缓存的对象
     */
    public <T> long setCacheList(final String key, final List<T> dataList) {
        Long count = redisTemplate.opsForList().rightPushAll(key, dataList);
        return count == null ? 0 : count;
    }

    /**
     * 缓存List数据（直接覆盖，不追加）
     *
     * @param key
     * @param dataList
     * @param <T>
     * @return
     */
    public <T> long setCacheListIfPresent(final String key, final List<T> dataList) {
        Long count = redisTemplate.opsForList().rightPushIfPresent(key, dataList);
        return count == null ? 0 : count;
    }


    /**
     * 获得缓存的list对象
     *
     * @param key 缓存的键值
     * @return 缓存键值对应的数据
     */
    public <T> List<T> getCacheList(final String key) {
        return redisTemplate.opsForList().range(key, 0, -1);
    }

    /**
     * 获得缓存的list对象
     *
     * @param key 缓存的键值
     * @return 缓存键值对应的数据
     */
    public Object leftPopCacheList(final String key) {
        return redisTemplate.opsForList().leftPop(key);
    }

    /**
     * 获得缓存的list对象
     *
     * @param key 缓存的键值
     * @return 缓存键值对应的数据
     */
    public Object rightPushCacheList(final String key, Object value) {
        return redisTemplate.opsForList().rightPush(key, value);
    }

    /**
     * 缓存Set
     *
     * @param key     缓存键值
     * @param dataSet 缓存的数据
     * @return 缓存数据的对象
     */
    public <T> BoundSetOperations<String, T> setCacheSet(final String key, final Set<T> dataSet) {
        BoundSetOperations<String, T> setOperation = redisTemplate.boundSetOps(key);
        for (T t : dataSet) {
            setOperation.add(t);
        }
        return setOperation;
    }

    /**
     * 获得缓存的set
     *
     * @param key 键
     * @return set
     */
    public <T> Set<T> getCacheSet(final String key) {
        return redisTemplate.opsForSet().members(key);
    }

    /**
     * 缓存Map
     *
     * @param key     键
     * @param dataMap 键
     */
    public <T> void setCacheMap(final String key, final Map<String, T> dataMap) {
        if (dataMap != null) {
            redisTemplate.opsForHash().putAll(key, dataMap);
        }
    }

    /**
     * 获得缓存的Map
     *
     * @param key 键
     * @return Map
     */
    public <T> Map<String, T> getCacheMap(final String key) {
        return redisTemplate.opsForHash().entries(key);
    }

    /**
     * 往Hash中存入数据
     *
     * @param key   Redis键
     * @param hKey  Hash键
     * @param value 值
     */
    public <T> void setCacheMapValue(final String key, final String hKey, final T value) {
        redisTemplate.opsForHash().put(key, hKey, value);
    }

    /**
     * 获取Hash中的数据
     *
     * @param key  Redis键
     * @param hKey Hash键
     * @return Hash中的对象
     */
    public <T> T getCacheMapValue(final String key, final String hKey) {
        HashOperations<String, String, T> opsForHash = redisTemplate.opsForHash();
        return opsForHash.get(key, hKey);
    }

    /**
     * 获取多个Hash中的数据
     *
     * @param key   Redis键
     * @param hKeys Hash键集合
     * @return Hash对象集合
     */
    public <T> List<T> getMultiCacheMapValue(final String key, final Collection<Object> hKeys) {
        return redisTemplate.opsForHash().multiGet(key, hKeys);
    }

    /**
     * 获得缓存的基本对象列表
     *
     * @param pattern 字符串前缀
     * @return 对象列表
     */
    public Collection<String> keys(final String pattern) {
        return redisTemplate.keys(pattern);
    }

    /**
     * redis分布式锁，只尝试一次，设置锁失效时间
     *
     * @param key 键
     * @Description:
     * @return: Boolean
     * @Author: sui q
     * @Date: 2022/8/27 15:04
     */
    public Boolean lockKeyOnce(final String key, Integer timeout) {
        return redisTemplate.opsForValue().setIfAbsent(key, "", timeout, TimeUnit.SECONDS);
    }

    /**
     * redis分布式锁，只尝试一次,锁默认10秒失效
     *
     * @param key 键
     * @Description:
     * @return: Boolean
     * @Author: sui q
     * @Date: 2022/8/27 15:04
     */
    public Boolean lockKeyOnce(final String key) {
        return redisTemplate.opsForValue().setIfAbsent(key, "", Constants.TIMEOUT_SECOND, TimeUnit.SECONDS);
    }

    /**
     * redis分布式锁，只尝试一次,锁默认10秒失效
     *
     * @param keyList 键
     * @Description:
     * @return: Boolean
     * @Author: sui q
     * @Date: 2022/8/27 15:04
     */
    public Boolean lockKeyByList(final List<String> keyList) {
        for (String key : keyList) {
            if (Objects.equals(redisTemplate.opsForValue().setIfAbsent(key, "", Constants.TIMEOUT_SECOND, TimeUnit.SECONDS), Boolean.FALSE)) {
                return Boolean.FALSE;
            }
        }
        return Boolean.TRUE;
    }

    /**
     * 清除锁
     *
     * @param key 键
     */
    public void unlock(String key) {
        if (Objects.equals(redisTemplate.hasKey(key), Boolean.TRUE)) {
            redisTemplate.delete(key);
        }
    }

    /**
     * 清除锁
     *
     * @param keyList 键
     */
    public void unlockByList(List<String> keyList) {
        for (String key : keyList) {
            if (Objects.equals(redisTemplate.hasKey(key), Boolean.TRUE)) {
                redisTemplate.delete(key);
            }
        }
    }

    /**
     * redis分布式锁，尝试多次
     *
     * @param key    键
     * @param number 尝试次数
     * @Description:
     * @return: Boolean
     * @Author: sui q
     * @Date: 2022/8/27 15:04
     */
    public Boolean lockKeyMany(final String key, Integer... number) {
        Integer lockNumber = Constants.LOCK_NUMBER;
        if (number != null && number.length > 0) {
            lockNumber = number[0];
        }
        for (int i = 0; i < lockNumber; i++) {
            // 超时时间为10秒
            Boolean lockBool = redisTemplate.opsForValue().setIfAbsent(key, "", Constants.TIMEOUT_SECOND, TimeUnit.SECONDS);
            if (lockBool != null && lockBool) {
                return true;
            } else {
                try {
                    // 如果获取锁失败，等待180毫秒后重试
                    Thread.sleep(100);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
//        throw new RuntimeException(MemberMsgConstants.MEMBER_IS_OPERATION);
        throw new RuntimeException("有其他用户在操作该数据，请重新刷新界面！");
    }


    /**
     * 获取redis HashOperations
     *
     * @return 键
     */
    public <T> HashOperations<String, String, T> getRedisHashOperations() {
        return redisTemplate.opsForHash();
    }

}
